﻿--shift+左键拖动
local function UnitFramesPlus_FocusShiftDrag()
	FocusFrame:SetScript("OnMouseDown", function(self, elapsed)
		if UnitFramesPlusDB["focus"]["movable"] == 1 then
			if IsShiftKeyDown() and (not InCombatLockdown()) then
				FocusFrame:StartMoving();
				UnitFramesPlusDB["focus"]["moving"] = 1;
			end
		end
	end)

	FocusFrame:SetScript("OnMouseUp", function(self, elapsed)
		if UnitFramesPlusDB["focus"]["moving"] == 1 then
			FocusFrame:StopMovingOrSizing();
			UnitFramesPlusDB["focus"]["moving"] = 0;
		end
	end)

	FocusFrame:SetClampedToScreen(1);
end

--自动开启系统扩大焦点框架
local function UnitFramesPlus_SysFocus()
	if UnitFramesPlusDB["focus"]["fullsize"] ~= 0 then
		SetCVar("fullSizeFocusFrame", 1, 1);
	else
		SetCVar("fullSizeFocusFrame", 0, 1);
	end
end

--生命值百分比
local FocusHPPct = CreateFrame("Frame", "FocusHPPct", FocusFrame);
FocusHPPct:SetWidth(45);
FocusHPPct:SetHeight(20);
FocusHPPct:SetPoint("RIGHT", FocusFrameHealthBar, "LEFT", -5, -1);
FocusHPPct.Text = FocusHPPct:CreateFontString("FocusHPPctText", "ARTWORK", "TextStatusBarText");
FocusHPPct.Text:SetAllPoints(FocusHPPct);
FocusHPPct.Text:SetFont(GameFontNormal:GetFont(), 12, "OUTLINE");
FocusHPPct.Text:SetTextColor(1, 0.75, 0);
FocusHPPct.Text:SetJustifyH("RIGHT");
function UnitFramesPlus_FocusHealthPct()
	if UnitFramesPlusDB["focus"]["hppct"] == 1 then
		FocusHPPct:RegisterEvent("PLAYER_FOCUS_CHANGED");
		FocusHPPct:RegisterEvent("UNIT_HEALTH");
		FocusHPPct:SetScript("OnEvent", function(self, event, ...)
			if event == "PLAYER_FOCUS_CHANGED" then
				UnitFramesPlus_FocusHealthPctDisplayUpdate();
			elseif event == "UNIT_HEALTH" then
				local unit = ...;
				if unit == "focus" then
					UnitFramesPlus_FocusHealthPctDisplayUpdate();
				end
			end
		end)
	else
		FocusHPPct.Text:SetText("");
		FocusHPPct:UnregisterEvent("UNIT_HEALTH");
		FocusHPPct:UnregisterEvent("PLAYER_FOCUS_CHANGED");
		FocusHPPct:SetScript("OnEvent", nil);
	end
end

--在设置插件时即时更新显示
function UnitFramesPlus_FocusHealthPctDisplayUpdate()
	if UnitFramesPlusDB["focus"]["hppct"] == 1 then
		local HPPct = "";
		local CurHP = UnitHealth("focus");
		local MaxHP = UnitHealthMax("focus");
		if MaxHP > 0 then
			HPPct = math.floor(100*CurHP/MaxHP).."%";
		end
		FocusHPPct.Text:SetText(HPPct);
	end
end

--法力值百分比
local FocusMPPct = CreateFrame("Frame", "FocusMPPct", FocusFrame);
FocusMPPct:SetWidth(45);
FocusMPPct:SetHeight(20);
FocusMPPct:SetPoint("RIGHT", FocusFrameManaBar, "LEFT", -5, -1);
FocusMPPct.Text = FocusMPPct:CreateFontString("FocusMPPctText", "ARTWORK", "TextStatusBarText");
FocusMPPct.Text:SetAllPoints(FocusMPPct);
FocusMPPct.Text:SetFont(GameFontNormal:GetFont(), 12, "OUTLINE");
FocusMPPct.Text:SetTextColor(1, 1, 1);
FocusMPPct.Text:SetJustifyH("RIGHT");
function UnitFramesPlus_FocusManaPct()
	if UnitFramesPlusDB["focus"]["mppct"] == 1 then
		FocusMPPct:RegisterEvent("UNIT_POWER");
		FocusMPPct:RegisterEvent("PLAYER_FOCUS_CHANGED");
		FocusMPPct:SetScript("OnEvent", function(self, event, ...)
			if event == "PLAYER_FOCUS_CHANGED" then
				UnitFramesPlus_FocusManaPctDisplayUpdate();
			elseif event == "UNIT_POWER" then
				local unit = ...;
				if unit == "focus" then
					UnitFramesPlus_FocusManaPctDisplayUpdate();
				end
			end
		end)
	else
		FocusMPPct.Text:SetText("");
		FocusMPPct:UnregisterEvent("UNIT_POWER");
		FocusMPPct:UnregisterEvent("PLAYER_FOCUS_CHANGED");
		FocusMPPct:SetScript("OnEvent", nil);
	end
end

--在设置插件时即时更新显示
function UnitFramesPlus_FocusManaPctDisplayUpdate()
	if UnitFramesPlusDB["focus"]["mppct"] == 1 then
		local MPPct = "";
		local CurMP = UnitPower("focus");
		local MaxMP = UnitPowerMax("focus");
		local powerType = UnitPowerType("focus");
		if powerType == 0 then
			if MaxMP > 0 then
				MPPct = math.floor(100*CurMP/MaxMP).."%";
			end
		end
		FocusMPPct.Text:SetText(MPPct);
	end
end

--生命条百分比染色
function UnitFramesPlus_FocusColorHPBar()
	if UnitFramesPlusDB["focus"]["colorhp"] == 1 then
		FocusFrameHealthBar:SetScript("OnValueChanged", function(self, value)
			local _, MaxHP = self:GetMinMaxValues();
			local CurHP = self:GetValue();
			local Pct = math.floor(100*CurHP/MaxHP)/100;
			local r, g, b = 0, 1, 0;
			if Pct > 0.5 then
				r = (1.0-Pct)*2;
				g = 1.0;
			else
				r = 1.0;
				g = Pct*2;
			end
			if r < 0 then r = 0 end
			if g < 0 then g = 0 end
			if r > 1 then r = 1 end
			if g > 1 then g = 1 end
			FocusFrameHealthBar:SetStatusBarColor(r, g, b);
		end)
	else
		FocusFrameHealthBar:SetStatusBarColor(0, 1, 0);
		FocusFrameHealthBar:SetScript("OnValueChanged", nil);
	end
end

--种族和类型
local FocusType = FocusFrame:CreateFontString("FocusType", "ARTWORK", "TextStatusBarText");
FocusType:SetPoint("BOTTOMLEFT", FocusFrameNameBackground, "TOPLEFT", 6, 2);
FocusType:SetFont(GameFontNormal:GetFont(), 12, "OUTLINE");
FocusType:SetTextColor(1, 0.75, 0);

local FocusRace = FocusFrame:CreateFontString("FocusRace", "ARTWORK", "TextStatusBarText");
FocusRace:SetPoint("BOTTOMLEFT", FocusFrameNameBackground, "TOPLEFT", 6, 2);
FocusRace:SetFont(GameFontNormal:GetFont(), 12, "OUTLINE");
FocusRace:SetTextColor(1, 0.75, 0);

local tr = CreateFrame("Frame");
function UnitFramesPlus_FocusRace()
	if UnitFramesPlusDB["focus"]["race"] == 1 then
		tr:RegisterEvent("PLAYER_FOCUS_CHANGED");
		tr:SetScript("OnEvent", function(self, event)
			UnitFramesPlus_FocusRaceDisplayUpdate();
		end)
	else
		FocusType:SetText("");
		FocusRace:SetText("");
		tr:UnregisterEvent("PLAYER_FOCUS_CHANGED");
		tr:SetScript("OnEvent", nil);
	end
end

--在设置插件时即时更新显示
function UnitFramesPlus_FocusRaceDisplayUpdate()
	local typeText = "";
	local raceText = "";
	if UnitFramesPlusDB["focus"]["race"] == 1 then
		if UnitIsPlayer("focus") then
			raceText = UnitRace("focus");
		else
			if UnitCreatureType("focus") and UnitCreatureType("focus") ~= "Unknown" and UnitCreatureType("focus") ~= "未指定" and UnitCreatureType("focus") ~= "未知" then
				typeText = string.sub(UnitCreatureType("focus"), 1, 6);
			end
		end
	end
	FocusType:SetText(typeText);
	FocusRace:SetText(raceText);
end

--职业图标
local ClassIcon = CreateFrame("Button", "FocusClass", FocusFrame);
ClassIcon:Hide();
ClassIcon:SetWidth(32);
ClassIcon:SetHeight(32);
ClassIcon:SetPoint("TOPLEFT", FocusFrame, "TOPLEFT", 119, 3);
ClassIcon:SetHighlightTexture("Interface\\Minimap\\UI-Minimap-ZoomButton-Highlight")

ClassIcon.Border = ClassIcon:CreateTexture("FocusClassBorder", "OVERLAY");
ClassIcon.Border:SetTexture("Interface\\Minimap\\MiniMap-TrackingBorder");
ClassIcon.Border:SetWidth(54);
ClassIcon.Border:SetHeight(54);
ClassIcon.Border:SetPoint("CENTER", 11, -12);

ClassIcon.Background = ClassIcon:CreateTexture("FocusClassBackground", "BORDER");
ClassIcon.Background:SetTexture("Interface\\Minimap\\UI-Minimap-Background");
ClassIcon.Background:SetWidth(20);
ClassIcon.Background:SetHeight(20);
ClassIcon.Background:SetPoint("CENTER");
ClassIcon.Background:SetVertexColor(0, 0, 0, 1);

ClassIcon.Icon = ClassIcon:CreateTexture("FocusClassIcon", "ARTWORK");
ClassIcon.Icon:SetTexture("Interface\\WorldStateFrame\\Icons-Classes");
ClassIcon.Icon:SetWidth(20);
ClassIcon.Icon:SetHeight(20);
ClassIcon.Icon:SetPoint("CENTER");

local fci = CreateFrame("Frame");
function UnitFramesPlus_FocusClassIcon()
	if UnitFramesPlusDB["focus"]["classicon"] == 1 then
		fci:RegisterEvent("PLAYER_FOCUS_CHANGED");
		fci:SetScript("OnEvent", function(self, event)
			UnitFramesPlus_FocusClassIconDisplayUpdate();
		end)
	else
		ClassIcon:Hide();
		fci:UnregisterEvent("PLAYER_FOCUS_CHANGED");
		fci:SetScript("OnEvent", nil)
	end
end

--在设置插件时即时更新显示
function UnitFramesPlus_FocusClassIconDisplayUpdate()
	if UnitFramesPlusDB["focus"]["classicon"] == 1 then
		if UnitIsPlayer("focus") then
			local coord = CLASS_BUTTONS[select(2, UnitClass("focus"))];
			FocusClassIcon:SetTexCoord(unpack(coord));
			ClassIcon:Show();
		else
			ClassIcon:Hide();
		end
	else
		ClassIcon:Hide();
	end
end

--职业图标左键观察，右键交易，中键密语
local isclicked = false;
local function FocusClassIconDown()
	local point, relativeTo, relativePoint, offsetX, offsetY = FocusClassIcon:GetPoint();
	FocusClassIcon:ClearAllPoints();
	FocusClassIcon:SetPoint(point, relativeTo, relativePoint, offsetX+1, offsetY-1);
	return true;
end

ClassIcon:SetScript("OnMouseDown", function(self, button)
	if UnitFramesPlusDB["focus"]["moreaction"] == 1 then
		if (not UnitCanAttack("player", "focus")) and UnitIsPlayer("focus") then
			if button == "LeftButton" then
				if CheckInteractDistance("focus", 1) then
					isclicked = FocusClassIconDown();
					InspectUnit("focus");
				end
			elseif button == "RightButton" then
				if CheckInteractDistance("focus", 2) then
					isclicked = FocusClassIconDown();
					InitiateTrade("focus");
				end
			elseif button == "MiddleButton" then
				isclicked = FocusClassIconDown();
				local server = nil;
				local name, server = UnitName("focus");
				local fullname = name;
				if server and (not "focus" or not UnitIsSameServer("player", "focus")) then
					fullname = name.."-"..server;
				end
				ChatFrame_SendTell(fullname);
			elseif button == "Button4" then
				if CheckInteractDistance("focus",4) then
					isclicked = FocusClassIconDown();
					local server = nil;
					local name, server = UnitName("focus");
					local fullname = name;
					if server and (not "focus" or not UnitIsSameServer("player", "focus")) then
						fullname = name.."-"..server;
					end
					FollowUnit(fullname, 1);
				end
			end
		end
	end
end)

local function FocusClassIconUp()
	local point, relativeTo, relativePoint, offsetX, offsetY = FocusClassIcon:GetPoint();
	FocusClassIcon:ClearAllPoints();
	FocusClassIcon:SetPoint(point, relativeTo, relativePoint, offsetX-1, offsetY+1);
	return false;
end

ClassIcon:SetScript("OnMouseUp", function(self)
	if UnitFramesPlusDB["focus"]["moreaction"] == 1 and isclicked then
		isclicked = FocusClassIconUp();
	end
end)

--头像内战斗信息
local FocusPortraitIndicator = CreateFrame("Frame", "FocusPortraitIndicator", FocusFrame);
FocusPortraitIndicator:CreateFontString("FocusHitIndicator", "OVERLAY", "NumberFontNormalHuge");
FocusHitIndicator:SetPoint("CENTER", FocusFramePortrait, "CENTER", 0, 0);
CombatFeedback_Initialize(FocusPortraitIndicator, FocusHitIndicator, 28);
function UnitFramesPlus_FocusPortraitIndicator()
	if UnitFramesPlusDB["focus"]["indicator"] == 1 then
		FocusPortraitIndicator:RegisterEvent("UNIT_COMBAT");
		FocusPortraitIndicator:RegisterEvent("PLAYER_FOCUS_CHANGED");
		FocusPortraitIndicator:SetScript("OnEvent", function(self, event, ...)
			if event == "PLAYER_FOCUS_CHANGED" then
				FocusHitIndicator:Hide();
				return;
			end

			local arg1, arg2, arg3, arg4, arg5 = ...;
			if event == "UNIT_COMBAT" and arg1 == "focus" then
				CombatFeedback_OnCombatEvent(self, arg2, arg3, arg4, arg5);
				return;
			end
		end)

		FocusPortraitIndicator:SetScript("OnUpdate", function(self, elapsed)
			CombatFeedback_OnUpdate(self, elapsed);
		end)
	else
		FocusHitIndicator:Hide();
		FocusPortraitIndicator:UnregisterEvent("UNIT_COMBAT");
		FocusPortraitIndicator:UnregisterEvent("PLAYER_FOCUS_CHANGED");
		FocusPortraitIndicator:SetScript("OnEvent", nil)
		FocusPortraitIndicator:SetScript("OnUpdate", nil)
	end
end

--快速设置焦点 源自Focuser by slizen
local modifierButtons = {"alt", "shift", "ctrl"};
local modifier = "alt";
local mouseButton = "1";-- 1 = left, 2 = right, 3 = middle, 4 and 5 = thumb buttons if there are any
local actionType = "focus";-- focus, target

local CreateFrame_Hook = function(type, name, parent, template)
	if name and template == "SecureUnitButtonTemplate" then
		_G[name]:SetAttribute(modifier.."-type"..mouseButton, actionType);
	end
end

local frametarget = CreateFrame("CheckButton", "ActionButtonTarget", UIParent, "SecureActionButtonTemplate");
frametarget:SetAttribute("type1", "macro");
frametarget:SetAttribute("macrotext", "/target mouseover");

hooksecurefunc("CreateFrame", CreateFrame_Hook)
local framefocus = CreateFrame("CheckButton", "ActionButton", UIParent, "SecureActionButtonTemplate");
framefocus:SetAttribute("type1", "macro");
framefocus:SetAttribute("macrotext", "/focus mouseover");

local duf = {
	PetFrame,
	PartyMemberFrame1,
	PartyMemberFrame2,
	PartyMemberFrame3,
	PartyMemberFrame4,
	PartyMemberFrame1PetFrame,
	PartyMemberFrame2PetFrame,
	PartyMemberFrame3PetFrame,
	PartyMemberFrame4PetFrame,
	PartyTarget1,
	PartyTarget2,
	PartyTarget3,
	PartyTarget4,
	TargetFrame,
	TargetFrameToT,
	TargetofTargetTargetFrame,
}

function UnitFramesPlus_FocusQuickClear(button)
	actionType = "target";
	modifier = button;
	SetOverrideBindingClick(ActionButtonTarget, true, modifier.."-BUTTON"..mouseButton, "ActionButtonTarget");
	for i, frame in pairs(duf) do
		frame:SetAttribute(modifier.."-type"..mouseButton, actionType);
	end
end

function UnitFramesPlus_FocusQuickInit()
	if UnitFramesPlusDB["focus"]["quick"] == 1 then
		actionType = "focus";
		modifier = modifierButtons[UnitFramesPlusDB["focus"]["button"]];
		SetOverrideBindingClick(ActionButton, true, modifier.."-BUTTON"..mouseButton, "ActionButton");
		for i, frame in pairs(duf) do
			frame:SetAttribute(modifier.."-type"..mouseButton, actionType);
		end
	end
end

function UnitFramesPlus_FocusQuick()
	if UnitFramesPlusDB["focus"]["quick"] == 1 then
		UnitFramesPlus_FocusQuickInit();
	else
		UnitFramesPlus_FocusQuickClear(modifierButtons[UnitFramesPlusDB["focus"]["button"]]);
	end
end

--3D头像
local Focus3DPortrait = CreateFrame("PlayerModel", "Focus3DPortrait", FocusFrame);
Focus3DPortrait:SetFrameStrata("BACKGROUND");
Focus3DPortrait:ClearAllPoints();
Focus3DPortrait:SetPoint("CENTER", FocusFramePortrait, "CENTER", 0, -2);
Focus3DPortrait:SetWidth(52);
Focus3DPortrait:SetHeight(52);
Focus3DPortrait:Hide();

local f3d = CreateFrame("Frame");
function UnitFramesPlus_Focus3DPortrait()
	if UnitFramesPlusDB["focus"]["p3d"] == 1 then
		FocusFramePortrait:Hide();
		Focus3DPortrait:Show();
		f3d:RegisterEvent("PLAYER_FOCUS_CHANGED");
		f3d:RegisterEvent("UNIT_PORTRAIT_UPDATE");
		f3d:RegisterEvent("UNIT_MODEL_CHANGED");
		f3d:RegisterEvent("UNIT_CONNECTION");
		f3d:RegisterEvent("UNIT_HEALTH");
		f3d:RegisterEvent("UNIT_ENTERED_VEHICLE");
		f3d:RegisterEvent("UNIT_EXITED_VEHICLE");
		f3d:SetScript("OnEvent", function(self, event, ...)
			local unit = ...;
			if event == "PLAYER_FOCUS_CHANGED" or ((event == "UNIT_PORTRAIT_UPDATE" or event == "UNIT_MODEL_CHANGED" or event == "UNIT_CONNECTION") and unit == "focus") then
				UnitFramesPlus_Focus3DPortraitDisplayUpdate();
			elseif event == "UNIT_HEALTH" and unit == "focus" then
				if (not UnitIsConnected("focus")) or UnitIsGhost("focus") then
					Focus3DPortrait:SetLight(1, 0, 0, 0, 0, 1.0, 0.25, 0.25, 0.25);
				elseif UnitIsDead("focus") then
					Focus3DPortrait:SetLight(1, 0, 0, 0, 0, 1.0, 1, 0.3, 0.3);
				else
					Focus3DPortrait:SetLight(1, 0, 0, 0, 0, 1.0, 1, 1, 1);
				end
			elseif event == "UNIT_ENTERED_VEHICLE" and unit == "focus" then
				FocusFramePortrait:Show();
				Focus3DPortrait:Hide();
			elseif event == "UNIT_EXITED_VEHICLE" and unit == "focus" then
				FocusFramePortrait:Hide();
				Focus3DPortrait:Show();
			end
		end)
	else
		FocusFramePortrait:Show();
		Focus3DPortrait:Hide();
		f3d:UnregisterEvent("PLAYER_FOCUS_CHANGED");
		f3d:UnregisterEvent("UNIT_PORTRAIT_UPDATE");
		f3d:UnregisterEvent("UNIT_MODEL_CHANGED");
		f3d:UnregisterEvent("UNIT_CONNECTION");
		f3d:UnregisterEvent("UNIT_HEALTH");
		f3d:UnregisterEvent("UNIT_ENTERED_VEHICLE");
		f3d:UnregisterEvent("UNIT_EXITED_VEHICLE");
		f3d:SetScript("OnEvent", nil)
	end
end

--在设置插件时即时更新显示
function UnitFramesPlus_Focus3DPortraitDisplayUpdate()
	if (not UnitExists("focus")) or (not UnitIsConnected("focus")) or (not UnitIsVisible("focus")) then
		Focus3DPortrait:SetPortraitZoom(0);
		Focus3DPortrait:SetCamDistanceScale(0.25);
		Focus3DPortrait:SetPosition(0,0,0.5);
		Focus3DPortrait:ClearModel();
		Focus3DPortrait:SetModel("Interface\\Buttons\\TalkToMeQuestionMark.M2");
	else
		Focus3DPortrait:SetPortraitZoom(1);
		Focus3DPortrait:SetCamDistanceScale(1);
		Focus3DPortrait:SetPosition(0,0,0);
		Focus3DPortrait:ClearModel();
		Focus3DPortrait:SetUnit("focus");
		if (not UnitIsConnected("focus")) or UnitIsGhost("focus") then
			Focus3DPortrait:SetLight(1, 0, 0, 0, 0, 1.0, 0.25, 0.25, 0.25);
		elseif UnitIsDead("focus") then
			Focus3DPortrait:SetLight(1, 0, 0, 0, 0, 1.0, 1, 0.3, 0.3);
		else
			Focus3DPortrait:SetLight(1, 0, 0, 0, 0, 1.0, 1, 1, 1);
		end
	end
end

function UnitFramesPlus_FocusInit()
	UnitFramesPlus_FocusShiftDrag();
	UnitFramesPlus_SysFocus();
	UnitFramesPlus_FocusHealthPct();
	UnitFramesPlus_FocusManaPct();
	UnitFramesPlus_FocusRace();
	UnitFramesPlus_FocusClassIcon();
	UnitFramesPlus_FocusColorHPBar();
	UnitFramesPlus_FocusPortraitIndicator();
	UnitFramesPlus_FocusQuickInit();
	UnitFramesPlus_Focus3DPortrait();
end
